<template>
  <div>
    <b-overlay
      :show="loading"
      :variant="'white'"
      :opacity="0.9"
      :blur="'2px'"
      style="padding: 1px;"
    >
      <div class="main-resource">

        <div class="resource-row">
          <div class="form-row file-row">
            <div
              v-if="resourceDataFormats.length && resource.data_source.data_format"
              class="form-group col-2"
            >
              <div class="format">
                {{ resourceDataFormats.find(el => el.id === resource.data_source.data_format).codename }}
              </div>
            </div>
            <div class="form-group col">
              <div class="file-name">
                {{ resource.data_source.href }} 
              </div>
            </div>
          </div>
          <div class="form-row">
            <div class="form-group col-12">
              <label>
                Modifier l'URL de la ressource:
              </label>
              <input
                v-model="newHref"
                class="form-control"
                placeholder="https://"
              >
            </div>
          </div>
          <div class="resource-form-footer">
            <b-button
              variant="danger"
              @click="() => {
                if (type === 'resource') {
                  isDeleteResourceFileModalOpen = true
                } else {
                  deleteResource()
                }
              }"
            >
              Supprimer
            </b-button>
            <b-button
              variant="outline-secondary"
              :disabled="!newHref"
              @click="type === 'resource' ? updateHrefResource() : updateHrefAnnexe()"
            >
              Mettre à jour
            </b-button>
          </div>
        </div>

        <div class="form-row">
          <div class="form-group col-12">
            <label class="required">Nom</label>
            <ValidationProvider ref="display_name" rules="required" :name="`Nom ${type === 'resource' ? 'ressource' : 'annexe'}`" v-slot="{ classes, errors }">
              <div class="control" :class="classes">
                <input
                  v-model="form.display_name"
                  class="form-control"
                  type="text"
                  :placeholder="`Nom ${type === 'resource' ? 'de la ressource' : ' de l\'annexe'}`"
                >
                <span class="form-errors">{{ errors[0] }}</span>
              </div>
            </ValidationProvider>
          </div>
        </div>
        <div class="form-row">
          <div class="form-group col-12">
            <label>Description</label>
            <textarea
              v-model="form.description"
              class="form-control"
            />
          </div>
        </div>
        <div class="form-row">
          <div class="form-group col-6">
            <label class="required">Type</label>
            <ValidationProvider ref="kind" rules="required" name="Type" v-slot="{ classes, errors }">
              <div class="control" :class="classes">
                <Multiselect
                  v-model="form.kind"
                  :options="resourceKinds"
                  :class="classes"
                  track-by="id"
                  label="display_name"
                  select-label=""
                  selected-label=""
                  deselect-label=""
                  :searchable="false"
                  placeholder="Sélectionner un type de ressource"
                />
                <span class="form-errors">{{ errors[0] }}</span>
              </div>
            </ValidationProvider>
          </div>
          <div class="form-group col-6">
            <label :class="type === 'resource' ? 'required' : ''">
              Date de dernière mise à jour
            </label>
            <ValidationProvider
              ref="last_update_date"
              :rules="type === 'resource' ? 'required' : ''"
              :name="`Date de dernière mise à jour ${type}`"
              v-slot="{ classes, errors }"
            >
              <div class="control" :class="type === 'resource' ? classes : ''">
                <input
                  v-model="form.last_update_date"
                  :class="{ empty: !form.last_update_date}"
                  class="form-control"
                  type="date"
                >
                <span class="form-errors">{{ errors[0] }}</span>
              </div>
            </ValidationProvider>
          </div>
        </div>
      </div>
    </b-overlay>
    <DeleteResourceModal
      :open="isDeleteResourceFileModalOpen"
      :resource="resource"
      @hide="isDeleteResourceFileModalOpen = false"
      @delete="deleteResource"
    />
  </div>
</template>

<script>
import { mapState, mapMutations, mapActions } from 'vuex';
import axios from 'axios';

import DeleteResourceModal from '@/components/ResourcesModals/DeleteResourceModal.vue';
import Multiselect from 'vue-multiselect';

import { ValidationObserver, ValidationProvider, extend, configure } from 'vee-validate';
import { required } from 'vee-validate/dist/rules';

extend('required', {
  ...required,
  message: 'Ce champ est requis'
});
configure({
  classes: {
    valid: 'is-valid',
    invalid: 'is-invalid'
  }
});

export default {
  name: 'HrefResourceEditor.vue',

  components: {
    DeleteResourceModal,
    ValidationObserver,
    ValidationProvider,
    Multiselect
  },

  props: {
    resource: {
      type: Object,
      default: () => {
        return {}
      }
    },
    resourceData: {
      type: Object,
      default: () => {
        return {}
      }
    },
    type: {
      type: String,
      default: 'resource'
    }
  },

  data() {
    return {
      loading: null,
      isDeleteResourceFileModalOpen: false,
      newHref: null,
      form: {
        display_name: null,
        description: null,
        kind: null,
        last_update_date: null
      }
    }
  },

  computed: {
    ...mapState('datasets', [
      'currentDataset'
    ]),
    ...mapState('resources', [
      'resourceDataFormats',
      'resourceKinds'
    ]),

    isFormChanged() {
      return this.form.display_name !== this.resource.display_name ||
        this.form.description !== this.resource.description ||
        this.form.kind !== this.resource.kind ||
        this.form.last_update_date !== this.resource.last_update_date;
    }
  },

  created() {
    if (this.resourceDataFormats.length === 0) {
      this.GET_RESOURCE_DATA_FORMATS();
    }
    if (this.resourceKinds.length === 0) {
      this.GET_RESOURCE_KINDS();
    }
    this.form.display_name = this.resource.display_name;
    this.form.description = this.resource.description;
    this.form.kind = this.resource.kind;
    this.form.last_update_date = this.resource.last_update_date;
  },

  mounted() {
    // Watch modal closing event
    this.$root.$on('bv::modal::hide', () => {
      this.isDeleteResourceFileModalOpen = false;
    });
  },

  methods: {
    ...mapMutations('resources', [
      'SET_RESOURCES_FILTERS',
    ]),
    ...mapActions('datasets', [
      'GET_DATASET_DETAIL',
    ]),
    ...mapActions('resources', [
      'UPDATE_HREF_RESOURCE',
      'UPDATE_HREF_ANNEXE',
      'GET_RESOURCES_LIST',
      'DELETE_RESOURCE_FROM_DATASET',
      'DELETE_RESOURCE',
      'PATCH_RESOURCE',
      'GET_RESOURCE_KINDS'
    ]),

    resetForm() {
      this.form = {
        display_name: this.resource.display_name,
        description: this.resource.description,
        kind: this.resource.kind,
        last_update_date: this.resource.last_update_date
      }
    },

    updateResourceInfos() {
      if (this.isFormChanged) {
        this.loading = true;
        this.PATCH_RESOURCE({
          id: this.resource.id,
          data: {
            display_name: this.form.display_name,
            description: this.form.description,
            kind: this.form.kind,
            last_update_date: this.form.last_update_date
          },
          datasetId: this.currentDataset.id
        }).then(() => {
          this.loading = false;
        });
      }
    },

    updateDatasetDetail() {
      this.GET_DATASET_DETAIL(this.currentDataset.id)
        .then(() => {
          this.SET_RESOURCES_FILTERS({
            filter: 'dataset_id',
            value: this.currentDataset.id
          });
          this.GET_RESOURCES_LIST();
          this.newHref = null;
          this.loading = false;
        })
        .catch(() => {
          this.loading = false;
        });
    },

    updateHrefResource() {
      const data = {
        href: this.newHref,
        id: this.resource.data_source.id
      };
      this.loading = true;
      this.UPDATE_HREF_RESOURCE({
        data: data,
        async: false,
      })
        .then(() => {
          this.updateDatasetDetail();
        })
        .catch(() => {
          this.loading = false;
        });
    },

    updateHrefAnnexe() {
      const data = {
        href: this.newHref,
        id: this.resource.data_source.id
      };
      this.loading = true;
      this.UPDATE_HREF_ANNEXE({
        data: data,
        datasetId: this.currentDataset.id,
        resourceId: this.resource.id,
        async: false,
      })
        .then(() => {
          this.updateDatasetDetail();
        })
        .catch(() => {
          this.loading = false;
        });
    },

    deleteResource() {
      // Find dataset from which resource needs to be removed
      const resourceToDatasetId = this.resource.datasets.find(el => el.dataset_id === this.currentDataset.id).id;
      const resourceDataToDatasetId =
        this.resourceData && this.resourceData.datasets ?
          this.resourceData.datasets.find(el => el.dataset_id === this.currentDataset.id).id :
          null;

      this.loading = true;
      axios.all([
        this.DELETE_RESOURCE_FROM_DATASET({
          resourceToDatasetId: resourceToDatasetId,
          resource: this.resource
        }),
        ... resourceDataToDatasetId ? [this.DELETE_RESOURCE_FROM_DATASET({
          resourceToDatasetId: resourceDataToDatasetId,
          resource: this.resourceData
        })] : []
      ])
        .then(() => {
          if (this.type === 'resource') {
            axios.all([
              this.DELETE_RESOURCE(this.resource),
              ... resourceDataToDatasetId ? [this.DELETE_RESOURCE(this.resourceData)] : []
            ])
          }
          this.$emit('delete');
          this.loading = false;
        })
        .catch((err) => {
          console.error(err);
          this.loading = false;
        });
    }
  }
}
</script>

<style lang="less" scoped>

.main-resource {
  margin: 0.5em 0 1em 1em;
  padding: 1em 1.5em 0.5em 0.5em;
  border: 2px solid #9BD0FF;
}

.close-icon {
  z-index: 1;
  cursor: pointer;
  position: absolute;
  left: 95%;
  top: 1.1em;
  padding: 0 !important;

  .bi-x {
    vertical-align: middle !important;
  }
}

.resource-row {
  border-bottom: solid 1px #9BD0FF;
  padding-bottom: 1.5rem;
  margin-bottom: 1.5rem;
}

.format {
  width: 100%;
  text-align: center;
  padding: 5px 10px;
  background-color: rgb(90, 90, 90);
  color: white;
  font-weight: 600;
}
.file-name {
  padding: 5px 10px;
  overflow: hidden;
  white-space: nowrap;
  text-overflow: ellipsis;
}

.file-row {
  margin: -1em 0 0 0.75em;
  padding: 2em 0 0;
  font-weight: 600;
  color: rgb(90, 90, 90);
}

.resource-form-footer {
  display: flex;
  justify-content: flex-end;
  margin: 0 0 1em 1em;
  button.btn-primary {
    border: 2px solid #9BD0FF;
    border-radius: 8px;
    margin-left: 1.5em;
  }
  button.btn-outline-secondary {
    background-color: #F7F8FA;
    border: 2px solid #A9B2B9;
    border-radius: 8px;
    color: #2F3234;
  }
  button.btn-outline-secondary:not(.disabled) {
    color: white;
    background-color: #4b4b4b;
  }
}

button.btn-danger {
  border: 2px solid #ff9b9b;
  border-radius: 8px;
  margin-right: 1.5em;
}

</style>
